/**
 * Course: CS2852
 * Term: Spring 2014
 * Assignment: Lab 2
 * Author: leonardj
 * Date: 03/25/14
 */

/**
 * This is a simple class to sort the x and y coordinates for each point.
 * @author leonardj
 * @created by leonardj on 3/25/14.
 */
public class Dot {

    /**
     * x coordinate
     */
    private double x;
    /**
     * y coordinate
     */
    private double y;
    /**
     * the critical value for the point
     */
    private double critVal;

    /**
     * Constructor.  Stores the coordinates.
     *
     * @param x x coordinate
     * @param y y coordinate
     */
    public Dot(double x, double y){
        this.x = x;
        this.y = y;
        critVal = 0;
    }

    /**
     * @return x
     */
    public double getX() {
        return x;
    }

    /**
     * @return y
     */
    public double getY() {
        return y;
    }

    /**
     * Determines the critical value for this point. Equation
     * was given in lab.
     *
     * @param before   The dot before
     * @param before   The dot after
     */
    public void setCritVal(Dot before, Dot after){
        double d1 = Math.sqrt(Math.pow(x - before.getX(), 2) + Math.pow(y - before.getY(), 2));
        double d2 = Math.sqrt(Math.pow(after.getX() - x, 2) + Math.pow(after.getY() - y, 2));
        double d3 = Math.sqrt(Math.pow(before.getX() - after.getX(), 2) + Math.pow(before.getY() - after.getY(), 2));
        critVal = d1 + d2 - d3;
    }

    /**
     * @return critVal
     */
    public double getCritVal() {
        return critVal;
    }
}
