/**
 * Course: CS2852
 * Term: Spring 2014
 * Assignment: Lab 2
 * Author: leonardj
 * Date: 03/25/14
 */
import edu.msoe.se1010.winPlotter.WinPlotter;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.List;

/**
 * This sets up the GUI to select a file, and display the points, lines, or both using the
 * WinPlotter package given to us.
 * @author leonardj
 * @created by leonardj on 3/25/14.
 */
public class Driver extends JFrame{

    /**
     * drives the program
     *
     * @param args
     */
    public static void main(String args[]){
        new Driver();
    }

    List<Dot> result = new ArrayList<Dot>();
    List<Dot> result2 = new LinkedList<Dot>();
    /**
     * This JFrame
     */
    JFrame parent = this;
    /**
     * List of points from the file
     */
    List<Dot> dots = new ArrayList<Dot>();
    /**
     * JLabel to display the number of points in the file
     */
    JLabel numPoint = new JLabel("Points in the file: ");
    /**
     * Used to display the picture
     */
    public WinPlotter wp = new WinPlotter();
    /**
     * JLabel for instructions
     */
    JLabel displayNum = new JLabel("Desired number of Dots: ");
    /**
     * JTextField used to enter desired number of dots
     */
    JTextField dotNum = new JTextField(10);
    /**
     * JButton to display dots
     */
    JButton plot = new JButton("Dots");
    /**
     * JButton to display lines
     */
    JButton lines = new JButton("Lines");
    /**
     * JButton to display dots and lines
     */
    JButton both = new JButton("Both");
    /**
     * JButton to load a file
     */
    JButton files = new JButton("Select File");

    /**
     * Constructor.  Creates the GUI and layout of the program and
     * connects the buttons to there ActionListeners.
     */
    public Driver(){
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setTitle("Picture Menu");
        setLocationRelativeTo(null);
        setSize(200, 200);
        setLayout(new FlowLayout());
        wp.setWindowSize(800, 800);
        wp.setGrid(true, .1, .1, Color.LIGHT_GRAY);
        wp.setPlotBoundaries(0, 0, 1, 1);
        files.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                /**
                 * ActionListener for selecting a file. It also converts the lines
                 * in the file into a list of dots.
                 */
                dots.clear();
                JFileChooser chooser = new JFileChooser();
                File workingDirectory = new File(System.getProperty("user.dir"));
                chooser.setCurrentDirectory(workingDirectory);
                int returnVal = chooser.showOpenDialog(parent);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File file = chooser.getSelectedFile();
                    Scanner in;
                    try {
                        in = new Scanner(file);
                        String[] tempString;
                        while (in.hasNextLine()) {
                            String line = in.nextLine();
                            tempString = line.split(",");
                            dots.add(new Dot(Double.parseDouble(tempString[0]), Double.parseDouble(tempString[1])));
                        }
                        numPoint.setText("Points in the file: " + dots.size());
                        plot.setEnabled(true);
                        lines.setEnabled(true);
                        both.setEnabled(true);

                        for (int x = 0; x < dots.size(); x++){
                            if (x == 0){
                                dots.get(x).setCritVal(dots.get(dots.size() - 1), dots.get(x + 1));
                            } else if (x == dots.size() - 1){
                                dots.get(x).setCritVal(dots.get(x - 1), dots.get(0));
                            } else{
                                dots.get(x).setCritVal(dots.get(x - 1), dots.get(x + 1));
                            }
                        }

                    } catch (Exception re) {
                        System.out.println("That file is invalid.");
                        dots.clear();
                        plot.setEnabled(false);
                        lines.setEnabled(false);
                        both.setEnabled(false);
                    }
                } else {
                    System.out.println("That file is invalid");
                    plot.setEnabled(false);
                    lines.setEnabled(false);
                    both.setEnabled(false);
                }

            }
        });
        add(files);
        add(numPoint);
        add(displayNum);
        add(dotNum);
        plot.setEnabled(false);
        plot.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                /**
                 * ActionListener for displaying dots.
                 */
                plotDots();
            }
        });
        add(plot);
        lines.setEnabled(false);
        lines.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                /**
                 * ActionListener for displaying lines.
                 */
                drawLines();
            }
        });
        add(lines);
        both.setEnabled(false);
        both.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                /**
                 * ActionListener for displaying dots and lines.
                 */
                drawLines();
                plotDots();
            }
        });
        add(both);
        setVisible(true);
    }

    /**
     * Accepts a list of dots, original, and copies the dots into a list,
     * result, that starts out empty.  The method then uses the technique described
     * in the lab assignment to remove all but the numDesired number of dots.
     * <br />
     * If fewer than numDesired dots are found in original, then a copy of all
     * the dots in original is returned.
     *
     * @param original   The list of dots read in from the data file
     * @param result     An empty list that will contain the numDesired most critical
     *                   dots from the original list
     * @param numDesired The number of dots desired in the resulting list, must be
     *                   at least 2
     * @return The number of nanoseconds required to execute
     */
    public static long getDesiredDots(List<Dot> original, List<Dot> result, int numDesired) {
        long startTime = System.currentTimeMillis();
        for (Dot d: original){
            result.add(d);
        }

        while (result.size() > numDesired){
            double low = Double.POSITIVE_INFINITY;
            int index = 0;
            for (int x = 0; x < result.size(); x++){
                if (x == 0){
                    result.get(x).setCritVal(result.get(result.size() - 1), result.get(x + 1));
                } else if (x == result.size() - 1){
                    result.get(x).setCritVal(result.get(x - 1), result.get(0));
                } else{
                    result.get(x).setCritVal(result.get(x - 1), result.get(x + 1));
                }
                if (result.get(x).getCritVal() < low){
                    low = result.get(x).getCritVal();
                    index = x;
                }
            }
            result.remove(index);
        }
        long endTime = System.currentTimeMillis();
        return endTime - startTime;
    }

    /**
     * Accepts a list of dots, original, and copies the dots into a list,
     * result, that starts out empty.  The method then uses the technique described
     * in the lab assignment to remove all but the numDesired number of dots.
     * <br />
     * If fewer than numDesired dots are found in original, then a copy of all
     * the dots in original is returned.
     *
     * @param original   The list of dots read in from the data file
     * @param result     An empty list that will contain the numDesired most critical
     *                   dots from the original list
     * @param numDesired The number of dots desired in the resulting list, must be
     *                   at least 3
     * @return The number of nanoseconds required to execute
     */
    public static long getDesiredDotsItr(List<Dot> original, Collection<Dot> result, int numDesired) {
        long startTime = System.currentTimeMillis();
        for (Dot d: original){
            result.add(d);
        }

        while (result.size() > numDesired){
            Dot smallest = original.get(0);
            for (Dot d: result){
                if (d.getCritVal() < smallest.getCritVal()){
                    smallest = d;
                }
            }
            result.remove(smallest);
        }
        long endTime = System.currentTimeMillis();
        return endTime - startTime;
    }










    public void drawLines(){
        wp.erase();
        wp.moveTo(dots.get(0).getX(), dots.get(0).getY());
        for (int x = 0; x < dots.size(); x++) {
            wp.drawTo(dots.get(x).getX(), dots.get(x).getY());
        }
        wp.drawTo(dots.get(0).getX(), dots.get(0).getY());
    }

    public void plotDots(){
        wp.erase();
        int convert;
        try {
            convert = Integer.parseInt(dotNum.getText());
        }catch (Exception ex){
            convert = 0;
        }
        if (convert >= dots.size()){
            for(int x = 0; x < dots.size(); x++){
                wp.drawPoint(dots.get(x).getX(), dots.get(x).getY());
            }
            dotNum.setText("");
        } else if (convert < dots.size() && convert > 1){
            //Indexed ArrayList
            System.out.println("Indexed ArrayList: " + getDesiredDots(dots, result, convert) + " milliseconds");
            System.out.println(result.size());
            for(Dot d: result){
                System.out.println(d.getX());
                wp.drawPoint(d.getX(), d.getY());
            }
            //Indexed LinkedList
            result.clear();
            System.out.println("Indexed LinkedList: " + getDesiredDots(dots, result2, convert) + " milliseconds");
            //Iterated ArrayList
            result2.clear();
            System.out.println("Iterated ArrayList: " + getDesiredDotsItr(dots, result, convert) + " milliseconds");
            //Iterated LinkedList
            System.out.println("Iterated LinkedList: " + getDesiredDotsItr(dots, result2, convert) + " milliseconds");

            dotNum.setText("");
        }
        else{
            dotNum.setText("");
        }
    }
}
